/*************************************************************************\
  "icoutput.h" - Intermediate Code Output (Phase E)
  Revision 5; 10 Nov 2002 - 15 Jan 2003
  Copyright (C) 2002-2003  Kevin P. Albrecht
\*************************************************************************/

#ifndef ICOUTPUT_H
#define ICOUTPUT_H

/////////////////////////
// DEFINES //////////////
/////////////////////////

/////////////////////////
// INCLUDES /////////////
/////////////////////////

#include "icm.h"

/////////////////////////
// DECLARATIONS /////////
/////////////////////////

// External //
void icoutput (char *filename);

/////////////////////////
// DEFINITIONS //////////
/////////////////////////

//// icmoutput
//// Output intermediate code to file
void icoutput (char *filename)
{
  // Vars //
  FILE *fileout;
  Statement *sm;
  int nInstruction = 0;

  // Open File //
  fileout = fopen (filename, "w");

  sm = icm_getnext();
  nInstruction++;

  while (sm != NULL)
  {
    fprintf (fileout, "%d  %s ", nInstruction, gvsTACStrings[sm->tac]);

    if (sm->a)
    {
      if (sm->a->rep == repIdent) fprintf (fileout, "%s ", sm->a->key);
      else
      {
        if (sm->a->type == tLabel)
          fprintf (fileout, "%s ", conv_is (*((int*)sm->a->value)));
        else if (sm->a->type == tRoutine)
          fprintf (fileout, "%s(%d)", (char *)(sm->a->key), ((Routine*)(sm->a->value))->location );
        else if (sm->a->type == tInt)
          fprintf (fileout, "%s ", conv_is (*((int*)sm->a->value)));
        else if (sm->a->type == tRat)
          fprintf (fileout, "%s ", conv_fs (*((float*)sm->a->value)));
        else if (sm->a->type == tStr)
          fprintf (fileout, "\"%s\" ", (char *)(sm->a->value));

        //fprintf (fileout, ":%s ", gvsTypeStrings[sm->a->type]);
      }
    }
    else fprintf (fileout, "");

    if (sm->b)
    {
      if (sm->b->rep == repIdent) fprintf (fileout, "%s ", sm->b->key);
      else
      {
        if (sm->b->type == tLabel)
          fprintf (fileout, "%s ", conv_is (*((int*)sm->b->value)));
        else if (sm->b->type == tRoutine)
          fprintf (fileout, "%s(%d)", (char *)(sm->b->key), ((Routine*)(sm->b->value))->location );
        else if (sm->b->type == tInt)
          fprintf (fileout, "%s ", conv_is (*((int*)sm->b->value)));
        else if (sm->b->type == tRat)
          fprintf (fileout, "%s ", conv_fs (*((float*)sm->b->value)));
        else if (sm->b->type == tStr)
          fprintf (fileout, "\"%s\" ", (char *)(sm->b->value));

        //fprintf (fileout, ":%s ", gvsTypeStrings[sm->b->type]);
      }
    }
    else fprintf (fileout, "");

    if (sm->c)
    {
      if (sm->c->rep == repIdent) fprintf (fileout, "%s ", sm->c->key);
      else
      {
        if (sm->c->type == tLabel)
          fprintf (fileout, "%s ", conv_is (*((int*)sm->c->value)));
        else if (sm->c->type == tRoutine)
          fprintf (fileout, "%s(%d)", (char *)(sm->c->key), ((Routine*)(sm->c->value))->location );
        else if (sm->c->type == tInt)
          fprintf (fileout, "%s ", conv_is (*((int*)sm->c->value)));
        else if (sm->c->type == tRat)
          fprintf (fileout, "%s ", conv_fs (*((float*)sm->c->value)));
        else if (sm->c->type == tStr)
          fprintf (fileout, "\"%s\" ", (char *)(sm->c->value));

        //fprintf (fileout, ":%s ", gvsTypeStrings[sm->c->type]);
      }
    }
    else fprintf (fileout, "");

    if (sm->number != 0) fprintf (fileout, "%d\n", sm->number);
    else                 fprintf (fileout, "\n");
     
    sm = icm_getnext();
    nInstruction++;
  }

  // Close File //
  fclose (fileout);
}

#endif
